import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.Timer;

import java.util.HashSet;

public class Config implements Serializable {
	
	private static final long serialVersionUID = -4979295517453925846L;
	
	int onMove;
	int[] score = { 0, 0 };
	int otocenych;
	Karticka otocena;
	int pocet;
	Karticka[][] karticka;
	PexesoApplet app;
	Timer time;
	final int maxCasNaTah = 15;
	int casNaTah = maxCasNaTah;
	
	Hrac h;
	Timer hracCasovac;
	
	class AListenerHrac implements ActionListener, Serializable {

		private static final long serialVersionUID = -5443823890613443077L;

		public void actionPerformed(ActionEvent arg0) {

			if (onMove == 1) {
				h.urobTah();
				if (onMove == 0) {
					hracCasovac.stop();
				}
			}
		} 
		
	}
	
	class AListener implements ActionListener, Serializable {

		private static final long serialVersionUID = 118555415015189952L;

		public void actionPerformed(ActionEvent arg0) {
			casNaTah--;
			
			if (casNaTah == -1) {
				casNaTah = maxCasNaTah;
				otocenych = 0;
				otocena = null;
				onMove = (onMove + 1) % 2;
				skryKarticky();
				if (onMove == 1) {
					hracCasovac.start();
				}
			}
			
			app.update();
		} 
		
	}
	
	class MAButton extends MouseAdapter implements Serializable {
		
		private static final long serialVersionUID = 8808902047359363425L;
		
		JButton butt;
		
		public MAButton(JButton b) {
			butt = b;
		}
		
		public void mousePressed(MouseEvent e) {
			if (butt.getName().length() > 1 && onMove == 0) {
				odkryKarticku(butt.getName());
				if (onMove == 1) {
					hracCasovac.start();
				}
			}
		}
		
	}
	
	public void odkryKarticku(String poz) {
		int i = (int)(poz.toCharArray()[0])-48;
		int j = (int)(poz.toCharArray()[1])-48;
		
		if ((otocenych == 2 || otocena != karticka[i][j]) && !karticka[i][j].otocena) {
			otocenych++;
			if (otocenych == 2) {
				if (otocena.obrazok == karticka[i][j].obrazok) {
					otocena.otocena = true;
					karticka[i][j].otocena = true;
					score[onMove]++;
				}
				else {
					onMove = (onMove + 1) % 2;
				}
				casNaTah = maxCasNaTah;
				time.restart();
				app.update();
			}
			else if (otocenych == 3) {
				otocenych = 1;
				skryKarticky();
				app.update();
			}
			otocena = karticka[i][j];
			karticka[i][j].button.setIcon(karticka[i][j].obrazok);
			
			h.zapamataj(karticka[i][j].obrazok, poz);
			
			if (jeVsetkoOdkryte()) {
				zobrazVyhru();
				
				time.stop();
				hracCasovac.stop();
			}
		}
	}
	
	public void zobrazVyhru() {
		String vyhra = "";
		
		if (score[0] > score[1]) {
			vyhra = "You have won this game!";
		}
		else if (score[0] < score[1]) {
			vyhra = "Your opponent have won this game!";
		}
		else {
			vyhra = "Draw!";
		}
		
		JOptionPane.showMessageDialog(app, vyhra);
	}
	
	private boolean jeVsetkoOdkryte() {
		for (int i = 0; i < pocet; i++) {
			for (int j = 0; j < pocet; j++) {
				if (!karticka[i][j].otocena) {
					return false;
				}
			}
		}
		return true;
	}
	
	public void skryKarticky() {
		for (int i = 0; i < pocet; i++) {
			for (int j = 0; j < pocet; j++) {
				if (!karticka[i][j].otocena) {
					karticka[i][j].button.setIcon(null);
				}
			}
		}
	}	
	
	private boolean volne() {
		boolean result = false;
		for (int i = 0; i < pocet; i++) {
			for (int j = 0; j < pocet; j++) {
				if (karticka[i][j].button.getText().compareTo("0") == 0) {
					result = true;
					break;
				}
			}
			if (result) {
				break;
			}
		}
		return result;
	}
	
	private boolean volne(int i, int j) {
		return karticka[i][j].button.getText().compareTo("0") == 0;
	}
	
	public void setPanel(JPanel panel) {
		panel.removeAll();
		for (int i = 0; i < pocet; i++) {
			for (int j = 0; j < pocet; j++) {
				panel.add(karticka[i][j].button);
				karticka[i][j].button.setForeground(null);
			}
		}
		time.start();
		if (onMove == 1) {
			hracCasovac.restart();
			hracCasovac.start();
		}
	}
	
	public void setApp(PexesoApplet a) {
		app = a;
	}

	public Config(int poc, PexesoApplet a, JPanel panel) {
		setApp(a);
		pocet = poc;
		
		onMove = 0;
		otocenych = 0;
		otocena = null;
		karticka = new Karticka[pocet][pocet];
		
		time = new Timer(1000, new AListener());
		
		h = new Hrac(this, pocet);
		hracCasovac = new Timer(1500, new AListenerHrac());
		
		for (int i = 0; i < pocet; i++) {
			for (int j = 0; j < pocet; j++) {
				karticka[i][j] = new Karticka(i,j);
			}
		}
		
		HashSet<Integer> pouzite = new HashSet<Integer>();
		
		while (volne()) {
			Integer c = new Integer((int)(Math.random() * pocet*pocet/2));
			while (pouzite.contains(c)) {
				c = (int)(Math.random() * pocet*pocet/2);
			}
			pouzite.add(c);
			
			String cis = new Integer(c).toString();
			if (cis.length() == 1) {
				cis = "0" + cis;
			}
			String cesta = "obr/pk0000";
			String pripona = ".gif";

			ImageIcon icon = new ImageIcon(getClass().getResource(cesta + cis + pripona));
			
			int rndi;   
			int rndj;   

			for (int i = 0; i < 2; i++) {
				while (true) {
					rndi = (int)(Math.random() * pocet);   
					rndj = (int)(Math.random() * pocet);
					
					if (volne(rndi, rndj)) {
						karticka[rndi][rndj].obrazok = icon;

						karticka[rndi][rndj].button.setText("");
						karticka[rndi][rndj].button.setIcon(null);
						karticka[rndi][rndj].button.addMouseListener(new MAButton(karticka[rndi][rndj].button));
						break;
					}
				}
			}
		}
		
		setPanel(panel);
	}
	
	public static Config load(String fileName) throws Exception {
		ObjectInputStream is = new ObjectInputStream(new FileInputStream(fileName));
		return (Config)is.readObject();
	}
	
	public void save(String fileName) throws Exception {
		ObjectOutputStream fs = new ObjectOutputStream(new FileOutputStream(fileName));
		fs.writeObject(this);
		fs.close();
	}
}