import java.io.Serializable;
import java.util.ArrayList;
import javax.swing.ImageIcon;

public class Hrac implements Serializable {

	private static final long serialVersionUID = 1202013081104380306L;
	
	private ArrayList<ImageIcon> obrazky;
	private ArrayList<String> pozicie;
	
	final int pamat = 24;
	int pocet;
	
	Config cfg;
	
	public Hrac(Config c, int p) {
		cfg = c;
		pocet = p;
		obrazky = new ArrayList<ImageIcon>();
		pozicie = new ArrayList<String>();
	}
	
	public void zapamataj(ImageIcon obr, String poz) {
		boolean ok = true;
		for (int i = 0; i < pozicie.size(); i++) {
			if (pozicie.get(i).compareTo(poz) == 0) {
				ok = false;
				break;
			}
		}
		
		if (ok) {
			obrazky.add(obr);
			pozicie.add(poz);
			
			if (obrazky.size() > pamat) {
				obrazky.remove(0);
				pozicie.remove(0);
			}
		}
	}
	
	public void urobTah() {
		if (cfg.otocenych == 2 || cfg.otocenych == 0) {
			
			for (int i = 0; i < obrazky.size(); i++) {
				for (int j = 0; j < obrazky.size(); j++) {
					if (i != j && obrazky.get(i) == obrazky.get(j)) {
						
						for (int k = 0; k < cfg.karticka.length; k++) {
							for (int l = 0; l < cfg.karticka[k].length; l++) {
								if (cfg.karticka[k][l].button.getIcon() == null) {
									if (cfg.karticka[k][l].button.getName().compareTo(pozicie.get(i)) == 0) {
										cfg.odkryKarticku(pozicie.get(i));
										return;	
									}
								}
							}
						}
						
					}
				}
			}
			
		}
		else {

			for (int i = 0; i < obrazky.size(); i++) {
				if (obrazky.get(i) == cfg.otocena.obrazok && pozicie.get(i).compareTo(cfg.otocena.button.getName()) != 0) {
					cfg.odkryKarticku(pozicie.get(i));
					return;
				}
			}			
		}
		
		int i;
		int j;
		
		while (true) {
			i = (int)(Math.random()*pocet);
			j = (int)(Math.random()*pocet);
			
			for (int k = 0; k < cfg.karticka.length; k++) {
				for (int l = 0; l < cfg.karticka[k].length; l++) {
					if (cfg.karticka[k][l].button.getName().compareTo(Integer.toString(i) + Integer.toString(j)) == 0 && !cfg.karticka[k][l].otocena) {
						cfg.odkryKarticku(Integer.toString(i) + Integer.toString(j));
						return;
					}
				}
			}
		}
		
	}
}