import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.applet.*;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class PexesoApplet extends Applet {
	
	private static final long serialVersionUID = -5813881953259102186L;
	
	private JLabel player, time, score;
	private JButton load, save, restart, quit;
	private JPanel infoPanel, playground, buttonPanel;
	
	private Config cfg;
	private final int pocet = 8;
	
	class MALoad extends MouseAdapter {
		
		PexesoApplet app;
		
		public MALoad(PexesoApplet a) {
			app = a;
		}
		
		public void mousePressed(MouseEvent e) {
			JFileChooser fc = new JFileChooser();
			if (fc.showOpenDialog(app) == JFileChooser.APPROVE_OPTION) {
				File f = fc.getSelectedFile(); 
				try {
					cfg = Config.load(f.getPath());
					cfg.setApp(app);
					cfg.setPanel(playground);
				} 
				catch (Exception e1) {
					System.err.println("Chyba pri otvarani suboru");
					e1.printStackTrace(System.err);
				}
			}
		}
	}
	
	class MASave extends MouseAdapter {
		
		PexesoApplet app;
		
		public MASave(PexesoApplet a) {
			app = a;
		}
		
		public void mousePressed(MouseEvent e) {
			JFileChooser fc = new JFileChooser();
			if (fc.showSaveDialog(app) == JFileChooser.APPROVE_OPTION) {
				File f = fc.getSelectedFile(); 
				try {
					cfg.save(f.getPath());
				} 
				catch (Exception e1) {
					System.err.println("Chyba pri otvarani suboru");
					e1.printStackTrace(System.err);
				}
			}
		}
	}
	
	class MARestart extends MouseAdapter {
		
		PexesoApplet app;
		
		public MARestart(PexesoApplet a) {
			app = a;
		}
		
		public void mousePressed(MouseEvent e) {
			cfg = new Config(pocet, app, playground);
		}
	}
	
	class MAQuit extends MouseAdapter {
		
		public void mousePressed(MouseEvent e) {
			System.exit(0);
		}
	}
	
	public void init() {
		setLayout(new BorderLayout());
		
		resize(400,450);
		
		infoPanel = new JPanel();
		playground = new JPanel();
		buttonPanel = new JPanel();
		
		infoPanel.setBackground(Color.GREEN);
		buttonPanel.setBackground(Color.GREEN);
		
		player = new JLabel("Player: ");
		time = new JLabel("Time: ");
		score = new JLabel("Score: ");
		
		infoPanel.add(player);
		infoPanel.add(time);
		infoPanel.add(score);
		
		load = new JButton("Load");
		save = new JButton("Save");
		restart = new JButton("Restart");
		quit = new JButton("Quit");
		
		load.addMouseListener(new MALoad(this));
		save.addMouseListener(new MASave(this));
		restart.addMouseListener(new MARestart(this));
		quit.addMouseListener(new MAQuit());
		
		buttonPanel.add(load);
		buttonPanel.add(save);
		buttonPanel.add(restart);
		buttonPanel.add(quit);
		
		playground.setLayout(new GridLayout(pocet, pocet));
		
		add("North", infoPanel);
		add("Center", playground);
		add("South", buttonPanel);
		
		cfg = new Config(pocet, this, playground);
		update();
	}
	
	public void update() {
		player.setText("Player: " + ((cfg.onMove == 0) ? "you" : "computer"));
		time.setText("Time: " + cfg.casNaTah + "s");
		score.setText("Score: " + cfg.score[0] + "/" + cfg.score[1]);
	}

}
